<script lang="ts">
import Vue from 'vue';
import Accordion from '../solutions/accordion.vue';

export default Vue.extend({
  name: 'DibWorkforceTabs',
  components: { Accordion },
  props: {
    data: {
      type: Array,
      required: true,
      default() {
        return [];
      },
    },
  },
  data() {
    return {
      tabs: [],
      selectedTab: 0,
      modal: {
        open: false,
        href: null,
      },
      isOpenIndex: null,
      showMore: false,
    };
  },
  methods: {
    onTabChange(value: number) {
      this.selectedTab = value;
    },
    toggleController(index: number) {
      if (this.isOpenIndex === index) {
        this.isOpenIndex = null;
        return;
      }
      this.isOpenIndex = index;
    },
  },
});
</script>

<template>
  <section class="dib-workforce-tabs">
    <SlpContainer>
      <div class="dib-workforce-tabs__wrapper">
        <div
          class="dib-workforce-tabs__tabs"
          role="tablist"
          aria-labelledby="tablist-1"
        >
          <button
            v-for="(tab, tabIndex) in data"
            :id="`tab-${tabIndex}`"
            :key="tab.header"
            ref="tab"
            type="button"
            role="tab"
            aria-selected="true"
            :aria-controls="`tabpanel-${tabIndex}`"
            class="dib-workforce-tabs__tab"
            :class="
              selectedTab == tabIndex ? 'dib-workforce-tabs__tab--active' : ''
            "
            @click="onTabChange(tabIndex)"
          >
            <SlpIcon
              :icon="`slp-${tab.icon}`"
              class="dib-workforce-tabs__icon"
              size="md"
            />
            <SlpTypography variant="body2" tag="div" :content="tab.header">
              {{ tab.header }}
            </SlpTypography>
          </button>
        </div>

        <div
          v-for="(tabContent, tabContentIndex) in data"
          v-show="tabContentIndex === selectedTab"
          :id="`tabpanel-${tabContentIndex}`"
          :key="`tab-content-${tabContentIndex}`"
          role="tabpanel"
          tabindex="0"
          :aria-labelledby="`tab-${tabContentIndex}`"
          class="dib-workforce-tabs__content"
          :class="
            selectedTab == tabContentIndex
              ? 'dib-workforce-tabs__content--active'
              : ''
          "
        >
          <SlpRow class="dib-workforce-tabs__row">
            <SlpColumn :col="6" class="dib-workforce-tabs__col">
              <SlpTypography
                variant="heading3-bold"
                tag="div"
                class="slp-mb-md-24"
              >
                <p v-html="tabContent.header"></p>
              </SlpTypography>

              <SlpTypography
                v-if="tabContent.content"
                variant="body2"
                tag="div"
                class="slp-mb-16"
              >
                <SlpMarkdown
                  :text="tabContent.content"
                  :class="tabContent.class" />

                <div v-if="tabContent.read_more?.text" class="slp-mt-32">
                  <SlpButton
                    v-if="!showMore"
                    class="dib-workforce-tabs__button"
                    variant="tertiary"
                    @click.native="showMore = !showMore"
                    >{{ tabContent.read_more.button_text }}
                    <SlpIcon icon="gl-plus" class="slp-ml-8" />
                  </SlpButton>
                  <Transition name="block-fade">
                    <div v-if="showMore">
                      <SlpMarkdown :text="tabContent.read_more.text" />
                      <SlpButton
                        class="dib-workforce-tabs__button"
                        variant="tertiary"
                        @click.native="showMore = !showMore"
                        >{{ tabContent.read_more.button_text_open }}
                        <SlpIcon icon="gl-dash" class="slp-ml-8" />
                      </SlpButton>
                    </div>
                  </Transition></div
              ></SlpTypography>
              <div v-if="tabContent.stats" class="dib-workforce-tabs__stats">
                <div
                  v-for="(stat, statIndex) in tabContent.stats"
                  :key="statIndex"
                  class="dib-workforce-tabs__stat"
                >
                  <SlpTypography
                    v-if="stat.value"
                    variant="heading2-bold"
                    tag="div"
                    class="slp-mr-16"
                  >
                    {{ stat.value }}
                  </SlpTypography>
                  <SlpTypography v-if="stat.blurb" variant="body1" tag="div">
                    {{ stat.blurb }}
                  </SlpTypography>
                </div>
              </div>
              <SlpTypography v-if="tabContent.legend" variant="body2" tag="div">
                <SlpMarkdown :text="tabContent.legend" />
              </SlpTypography>
              <div class="slp-mt-32">
                <Accordion
                  v-for="(item, index) in tabContent.accordion"
                  :key="item.header"
                  :data="item"
                  :is-open="isOpenIndex == index"
                  @toggleController="toggleController(index)"
                >
                  <template v-if="item.quote?.text" #additional-content>
                    <div class="dib-workforce-tabs__quote slp-mt-32">
                      <svg
                        xmlns="http://www.w3.org/2000/svg"
                        width="33"
                        height="28"
                        viewBox="0 0 33 28"
                        fill="none"
                      >
                        <path
                          d="M7.52 27.8C5.06667 27.8 3.2 26.8667 1.92 25C0.64 23.1333 0 20.5733 0 17.32C0 13.5333 0.933333 10.2 2.8 7.32C4.66667 4.44 7.52 2.06667 11.36 0.199997L13.92 5.32C11.52 6.49333 9.70667 7.90666 8.48 9.56C7.30667 11.16 6.72 13.1333 6.72 15.48C6.82667 15.4267 6.96 15.4 7.12 15.4C7.28 15.4 7.41333 15.4 7.52 15.4C9.22667 15.4 10.6667 15.9333 11.84 17C13.0667 18.0133 13.68 19.4267 13.68 21.24C13.68 23.2133 13.0933 24.8133 11.92 26.04C10.7467 27.2133 9.28 27.8 7.52 27.8ZM26.48 27.8C24.0267 27.8 22.16 26.8667 20.88 25C19.6 23.1333 18.96 20.5733 18.96 17.32C18.96 13.5333 19.8933 10.2 21.76 7.32C23.6267 4.44 26.48 2.06667 30.32 0.199997L32.88 5.32C30.48 6.49333 28.6667 7.90666 27.44 9.56C26.2667 11.16 25.68 13.1333 25.68 15.48C25.7867 15.4267 25.92 15.4 26.08 15.4C26.24 15.4 26.3733 15.4 26.48 15.4C28.1867 15.4 29.6267 15.9333 30.8 17C32.0267 18.0133 32.64 19.4267 32.64 21.24C32.64 23.2133 32.0533 24.8133 30.88 26.04C29.7067 27.2133 28.24 27.8 26.48 27.8Z"
                          fill="#171321"
                        />
                      </svg>
                      <SlpTypography tag="p" variant="quotes" class="slp-mb-24">
                        {{ item.quote.text }}</SlpTypography
                      >
                      <div class="dib-workforce-tabs__author">
                        <img
                          v-if="item.quote.headshot"
                          class="dib-workforce-tabs__headshot"
                          :src="item.quote.headshot.src"
                          :alt="item.quote.headshot.alt"
                        />

                        <div>
                          <SlpTypography
                            tag="p"
                            variant="body1-bold"
                            class="slp-mt-32"
                          >
                            {{ item.quote.name }}</SlpTypography
                          >
                          <SlpTypography tag="p" variant="body1">
                            {{ item.quote.role }}</SlpTypography
                          >
                        </div>
                      </div>
                    </div>
                  </template>
                </Accordion>
              </div>
            </SlpColumn>
            <SlpColumn
              v-if="tabContent.quote?.text"
              :col="6"
              class="dib-workforce-tabs__col"
            >
              <div class="dib-workforce-tabs__quote">
                <svg
                  xmlns="http://www.w3.org/2000/svg"
                  width="33"
                  height="28"
                  viewBox="0 0 33 28"
                  fill="none"
                >
                  <path
                    d="M7.52 27.8C5.06667 27.8 3.2 26.8667 1.92 25C0.64 23.1333 0 20.5733 0 17.32C0 13.5333 0.933333 10.2 2.8 7.32C4.66667 4.44 7.52 2.06667 11.36 0.199997L13.92 5.32C11.52 6.49333 9.70667 7.90666 8.48 9.56C7.30667 11.16 6.72 13.1333 6.72 15.48C6.82667 15.4267 6.96 15.4 7.12 15.4C7.28 15.4 7.41333 15.4 7.52 15.4C9.22667 15.4 10.6667 15.9333 11.84 17C13.0667 18.0133 13.68 19.4267 13.68 21.24C13.68 23.2133 13.0933 24.8133 11.92 26.04C10.7467 27.2133 9.28 27.8 7.52 27.8ZM26.48 27.8C24.0267 27.8 22.16 26.8667 20.88 25C19.6 23.1333 18.96 20.5733 18.96 17.32C18.96 13.5333 19.8933 10.2 21.76 7.32C23.6267 4.44 26.48 2.06667 30.32 0.199997L32.88 5.32C30.48 6.49333 28.6667 7.90666 27.44 9.56C26.2667 11.16 25.68 13.1333 25.68 15.48C25.7867 15.4267 25.92 15.4 26.08 15.4C26.24 15.4 26.3733 15.4 26.48 15.4C28.1867 15.4 29.6267 15.9333 30.8 17C32.0267 18.0133 32.64 19.4267 32.64 21.24C32.64 23.2133 32.0533 24.8133 30.88 26.04C29.7067 27.2133 28.24 27.8 26.48 27.8Z"
                    fill="#171321"
                  />
                </svg>
                <SlpTypography tag="p" variant="quotes" class="slp-mb-24">
                  {{ tabContent.quote.text }}</SlpTypography
                >
                <div class="dib-workforce-tabs__author">
                  <img
                    v-if="tabContent.quote.headshot"
                    class="dib-workforce-tabs__headshot"
                    :src="tabContent.quote.headshot.src"
                    :alt="tabContent.quote.headshot.alt"
                  />

                  <div>
                    <SlpTypography
                      tag="p"
                      variant="body1-bold"
                      class="slp-mt-32"
                    >
                      {{ tabContent.quote.name }}</SlpTypography
                    >
                    <SlpTypography tag="p" variant="body1">
                      {{ tabContent.quote.role }}</SlpTypography
                    >
                  </div>
                </div>
              </div>
            </SlpColumn>
          </SlpRow>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.dib-workforce-tabs {
  margin: 0 auto $spacing-64 auto;
  padding-top: $spacing-24;

  @media screen and (min-width: $breakpoint-sm) {
    margin: $spacing-48 auto $spacing-96 auto;
  }
  &__tab {
    margin-right: $spacing-32;
    border: none;
    position: relative;
    cursor: pointer;
    padding-bottom: $spacing-24;
    z-index: 1;
    transition: all 0.3s ease;
    img {
      max-height: 42px;
    }
    &:after {
      content: '';
      position: absolute;
      height: 4px;
      width: 100%;
      background-color: $color-accent-500;
      right: 0;
      left: 0;
      bottom: 0;
      transform: scaleX(0);
      opacity: 0;
      transition: transform 0.3s ease, opacity 0.3s ease;
      transform-origin: right;
    }
    &--active {
      :deep * {
        text-shadow: 0.6px 0 0 currentColor;
      }
      &:after {
        transform: scaleX(1);
        transform-origin: left;
        opacity: 1;
      }
    }
  }
  &__tabs {
    margin-bottom: $spacing-32;
    display: flex;
    align-items: center;
    position: relative;
    overflow-x: scroll;
    @media screen and (min-width: $breakpoint-sm) {
      margin-bottom: $spacing-64;
    }
  }

  &__icon {
    margin: 0 auto 8px auto;
  }

  &__quote {
    border-radius: 20px;
    border-radius: 20px;
    background: linear-gradient(
      90deg,
      #eee7fd 0%,
      rgba(246, 243, 254, 0.83) 49.71%,
      rgba(255, 212, 216, 0.45) 100%
    );
    padding: $spacing-24;
    @media screen and (min-width: $breakpoint-sm) {
      padding: $spacing-32;
    }
  }
  &__author {
    display: flex;
  }
  &__headshot {
    border-radius: 100%;
    width: 120px;
    height: 120px;
    overflow: hidden;
    margin-right: 16px;
    flex: 0 0 120px;
    object-fit: cover;

    img {
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
  }
  &__content {
    &--active {
      animation: fade-in 0.5s ease-in forwards;
    }
  }
  &__button-icon {
    height: 20px;
    width: 20px;
  }
  &__control-icon {
    height: 24px;
    width: 24px;
  }
  &__controls {
    display: flex;
    align-items: center;
    margin-top: 64px;
    width: 100%;
    justify-content: center;
    @media screen and (min-width: $breakpoint-sm) {
      display: none;
    }
  }
  &__list {
    display: flex;
    :deep .slp-btn {
      padding: 0;
      width: 10px;
      min-width: 10px;
    }
  }
  &__item {
    display: flex;
    align-items: center;
    margin: 0px 16px;
  }
  &__control {
    height: 10px;
    width: 10px;
    border-radius: 10px;
    background: $color-surface-300;
    cursor: pointer;
    transition: all 0.3s ease;
    &--active {
      background: $color-surface-700;
    }
  }
  &__prev,
  &__next {
    padding: 0;
    min-width: auto;
  }
  &__prev {
    :deep &.slp-btn-tertiary:hover .slp-icon {
      transform: translateX(-8px);
    }
  }
  &__row {
    margin-left: -32px;
  }
  &__col {
    padding-left: 32px;
  }
  &__button {
    color: $color-text-link-100;
    text-decoration: underline;
    :deep .slp-icon div {
      position: relative;
      svg {
        position: absolute;
        left: 0;
        top: 0;
      }
    }
    &:hover,
    &:focus {
      text-decoration-color: $color-text-link-100;
    }
  }
  &__stats {
    :deep ul {
      display: flex;
      flex-wrap: wrap;
      margin-left: -32px;
      margin-top: 40px;
      li {
        display: flex;
        flex: 1 0 100%;
        margin-left: 32px;
        align-items: center;
        border-top: 2px solid $color-surface-400;
        padding: 24px;
        @media screen and (min-width: $breakpoint-sm) {
          flex: 1 1 calc(33% - 32px);
        }
      }
      strong {
        font-size: 40px;
        font-weight: 600;
        letter-spacing: -1.2px;
        line-height: 48px;
        margin-right: 16px;
        @media screen and (min-width: $breakpoint-sm) {
          font-size: 50px;
          font-weight: 600;
          letter-spacing: -1.4px;
          line-height: 60px;
        }
      }
    }
  }

  :deep {
    .accordion .content p {
      line-height: 20px;
    }
    .accordion .content ul {
      list-style-type: disc;
      padding-left: 16px;
    }
  }

  .block-fade-enter-active {
    transition: all 0.5s;
  }

  .block-fade-leave-active {
    transition: all 0.3s ease-in;
  }

  .block-fade-enter,
  .block-fade-leave-to {
    transform: translateY(20px);
    opacity: 0;
    @media (prefers-reduced-motion) {
      opacity: 1;
      transform: none;
    }
  }
  .block-fade-leave,
  .block-fade-enter-to {
    opacity: 1;
  }

  @keyframes fade-in {
    from {
      opacity: 0;
      transform: translateY(10px);
    }
    to {
      opacity: 1;
      transform: translateY(0);
    }
  }
}
</style>
